<?php

class OrderJournalModel {
  public $name = null;
  public $order_id = null;
  public $text = null;
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;
  

  public static function create(Array $data) {
    $model = new OrderJournal();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model ->$field = $value;
      }
    }
    
    $me = new User();
    $me->loadMe();

    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }
    
    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("OrderJournal", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new OrderJournal($data);
    }
    return $item;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select("OrderJournal", "*");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new OrderJournal($data);
      }
    }
    return $items;
    
  }
  
  public static function getFirst($filter) {
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("OrderJournal", "*", "$where ORDER BY `create`");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new OrderJournal($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  
  public static function search($filter) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("OrderJournal", "*", "$where ORDER BY `create` DESC");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new OrderJournal($data);
      }
    }
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";

    //var_dump($filter);exit;
    if(array_key_exists("order_id", $filter)) {
      $orderid = $filter['order_id'];
      if(is_numeric($orderid)) {
        $where .= " AND order_id=$orderid";
      }
    }
    
    //var_dump($filter, $where);exit;
    return $where;
  }
  
}